#!/usr/bin/python

import sys
import string

inputLines = sys.stdin.readlines()
inputGroups = []
skippingBlanks = True

def isBlankLine(testLine):
	return ((testLine == "\n") or (testLine == "\r") or (testLine == "\r\n"))

for thisLine in inputLines:
	# Non-blank line? If we've been skipping
	# blanks, looking for valid blocks, then start a 
	# new group	
	if (isBlankLine(thisLine) == False):
		# We only strip trailing whitespace to preserve indentation
		strippedLine = thisLine.rstrip()
		if (skippingBlanks):
			inputGroups += [strippedLine,]
			skippingBlanks = False
		else:
			# Blanks go in as their own untouched thing (nor now?)
			inputGroups[-1] += "\n" + strippedLine
	else:
		# Got a blank, which, for now we just put in as its own group
		inputGroups += ["\n",]
		skippingBlanks = True

# Now for the output, we print out the non-blank lines surrounded by p tags,
# and print out the blanks verbatim
firstBlock = True
for thisBlock in inputGroups:
	if (isBlankLine(thisBlock)):
		sys.stdout.write(thisBlock)
	else:
		if (firstBlock == False):
			sys.stdout.write("\n")
		firstBlock = False
		
		thisBlock = thisBlock.strip()
		
		# We add paragraph tags fairly conservatively: only if the 
		# block we are looking at does not appear to be "wrapped" in any form
		# of HTML markup tags already. Note, it might be better to 
		# look more specifically for evidence of "block level" markup, but 
		# for now we just concede that if it looks wrapped, the user knows what they are doing.
		shouldAddParagraphTags = False
		if ((thisBlock.startswith("<") == False) or (thisBlock.endswith(">") == False)):
			shouldAddParagraphTags = True
			
		if (shouldAddParagraphTags):
			sys.stdout.write("<p>")

		sys.stdout.write(thisBlock)
		
		if (shouldAddParagraphTags):
			sys.stdout.write("</p>")
